#include <stdio.h>
#include <boost/thread.hpp>
#include <VDream/System.h> // for Sleep

class A
{
public:
  A()
  {
    printf("A::A\n");
    Sleep(1000);
  }
  virtual ~A()
  {
    printf("A::~A\n");
    Sleep(1000);
  }
  virtual void foo()
  {
    printf("A::foo\n");
  }
};

class B : public A
{
public:
  B()
  {
    printf("B::B\n");
    Sleep(1000);
  }
  virtual ~B()
  {
    printf("B::~B\n");
    Sleep(1000);
  }
  virtual void foo()
  {
    printf("B::foo\n");
  }
};

class C : public B
{
public:
  C()
  {
    printf("C::C\n");
    Sleep(1000);
  }
  virtual ~C()
  {
    printf("C::~C\n");
    Sleep(1000);
  }
  virtual void foo()
  {
    printf("C::foo\n");
  }
};

static C* c = NULL;
void fooFunc(int sleepTime)
{
  Sleep(sleepTime);
  c->foo(); // which foo function is called? 
}

int main()
{
  c = new C;
  boost::thread thread(fooFunc, 1500);
  delete c;
  thread.join();

  return 0;
}
