program vmt_test;

{$APPTYPE CONSOLE}

uses
  Classes, SysUtils;

type
  A = class
    constructor Create; virtual;
    destructor Destroy; override;
    procedure foo; virtual;
  end;

  B = class(A)
    constructor Create; override;  
    destructor Destroy; override;
    procedure foo; override;
  end;

  C = class(B)
    constructor Create; override;  
    destructor Destroy; override;
    procedure foo; override;
  end;

  TMyThread = class(TThread)
  protected
    procedure Execute; override;
  end;

var
  _c: C;

constructor A.Create;
begin
  inherited;
  WriteLn('A::A');
  Sleep(1000);
end;

destructor A.Destroy;
begin
  WriteLn('A::~A');
  Sleep(1000);
  inherited;
end;

procedure A.foo;
begin
  WriteLn('A::foo');
end;

constructor B.Create;
begin
  inherited;
  WriteLn('B::B');
  Sleep(1000);
end;

destructor B.Destroy;
begin
  WriteLn('B::~B');
  Sleep(1000);
  inherited;
end;

procedure B.foo;
begin
  WriteLn('B::foo');
end;

constructor C.Create;
begin
  inherited;
  WriteLn('C::C');
  Sleep(1000);
end;

destructor C.Destroy;
begin
  WriteLn('C::~C');
  Sleep(1000);
  inherited;
end;

procedure C.foo;
begin
  WriteLn('C::foo');
end;

procedure TMyThread.Execute;
begin
  Sleep(1500);
  _c.foo; // which foo function is called? 
end;

var
  MyThread: TMyThread;
  p: Pointer;
begin
  p := @C.Destroy;
  WriteLn(IntToHex(Integer(p), 8));
  _c := C.Create;
  MyThread := TMyThread.Create(false);
  _c.Free;
  MyThread.WaitFor;
end.
